'use strict';

Object.defineProperty(exports, '__esModule', {
	value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _immutableCursorsLibAPI = require('immutable-cursors/lib/API');

var _immutableCursorsLibAPI2 = _interopRequireDefault(_immutableCursorsLibAPI);

var _immutableCursorsLibPathToSeq = require('immutable-cursors/lib/pathToSeq');

var _immutableCursorsLibPathToSeq2 = _interopRequireDefault(_immutableCursorsLibPathToSeq);

var _TreeCursor = require('./TreeCursor');

var _TreeCursor2 = _interopRequireDefault(_TreeCursor);

var _TreeUtils = require('./TreeUtils');

var _TreeUtils2 = _interopRequireDefault(_TreeUtils);

var TreeAPI = (function (_API) {
	_inherits(TreeAPI, _API);

	function TreeAPI(treeUtils) {
		_classCallCheck(this, TreeAPI);

		_get(Object.getPrototypeOf(TreeAPI.prototype), 'constructor', this).call(this);
		this.treeUtils = treeUtils || new _TreeUtils2['default']();
	}

	_createClass(TreeAPI, [{
		key: 'treeFrom',
		value: function treeFrom(rootData, keyPath, onChange) {
			var path = (0, _immutableCursorsLibPathToSeq2['default'])(keyPath);
			return this.makeCursor(rootData, path, onChange, undefined, _TreeCursor2['default'], {
				rootPath: path
			});
		}
	}, {
		key: 'makeTreeCursor',
		value: function makeTreeCursor(cursor, keyPathOrList) {
			var _this = this;

			if (Array.isArray(keyPathOrList)) {
				return keyPathOrList.map(function (keyPath) {
					return _this.makeCursor(cursor._rootData, keyPath, cursor._onChange, undefined, _TreeCursor2['default'], cursor._sharedOptions);
				});
			} else {
				return this.makeCursor(cursor._rootData, keyPathOrList, cursor._onChange, undefined, _TreeCursor2['default'], cursor._sharedOptions);
			}
		}
	}, {
		key: 'export',
		value: function _export() {
			var api = _get(Object.getPrototypeOf(TreeAPI.prototype), 'export', this).call(this);
			api.treeFrom = this.treeFrom.bind(this);
			return api;
		}
	}]);

	return TreeAPI;
})(_immutableCursorsLibAPI2['default']);

exports['default'] = TreeAPI;
module.exports = exports['default'];